// RuntimeForStatic base library | C+- (SysRoutine) | Author: Sergei Y.Kitáev
#include "Precompiled.h"
#include "SharedIncludes.h"
namespace RuntimeForStatic {
//==================================================================================================

$TaskMemAutoArray::$TaskMemAutoArray($A, const std::initializer_list<PVOID volatile*>& ptrPointers
                                         $p_optional_list )
{
   for (auto pPointer: ptrPointers)
      $$VERIFY_POINTER_ARG( pPointer );
   _PtrPointers_ = ptrPointers;
   ValidateDisposable($$);
}

//==================================================================================================

void $TaskMemAutoArray::DoDispose($CI_REF)
{
   Free($ci);
}

void $TaskMemAutoArray::ResetSuperstructure()
{
   _PtrPointers_ = std::initializer_list<PVOID volatile*>();
}

//==================================================================================================

void $TaskMemAutoArray::Free($O)
{
   if ( IsValidDisposable )
   {
      $$VERIFY_VALID_DISPOSABLE();
      $TaskMem::FreeByPointers($$, _PtrPointers_ );
      ResetSuperstructure();
      InvalidateDisposable();
   }
}

//==================================================================================================
} // RuntimeForStatic
